<?xml version="1.0" encoding="UTF-8"?>
<schema xmlns="http://purl.oclc.org/dsdl/schematron" queryBinding="xslt2">
  <phase id="text">
    <active pattern="text_01"/>
  </phase>
  <phase id="structure">
    <active pattern="struct_01"/>
    <active pattern="calc_01"/>
  </phase>
  <phase id="webservice">
    <active pattern="web_01"/>
  </phase>
  <!-- Text -->
  <pattern id="text_01">
    <rule context="text()">
      <let name="match-string" value="'^([-+*/=_A-zÄäÖöÜü0-9$?;\\§:ß,\.\(\)&lt;&gt;]|\s)*$'"/>
      <assert test="matches(., $match-string)">ungültige(s) Zeichen: »<value-of select="
				string-join(
				distinct-values(for $i in string-to-codepoints(.) return codepoints-to-string($i))[not(matches(., $match-string))],
				'«, »'
				)
				"/>«</assert>
    </rule>
  </pattern>
  <!-- Struktur -->
  <pattern id="struct_01">
    <rule context="chapter">
      <assert test="index-of(('Inbetriebnahme', 'Bedienung', 'Glossar', 'Register'), @type) gt (index-of
																											(
																											('Inbetriebnahme', 'Bedienung', 'Glossar', 'Register'),
																												(((preceding::chapter)[last()]/@type),0)[1]
																											)
																											)" role="warn">Das Kapitel <value-of select="@type"/> steht in der Reihenfolge falsch.</assert>
    </rule>
  </pattern>
  <pattern id="struct_02">
    <rule context="dl">
      <assert test="ancestor::chapter[@type = 'Glossar']" role="warn">Das Element dl (Definition List) soll nur im Glossar verwendet werden.</assert>
    </rule>
  </pattern>
  <pattern id="struct_03">
    <rule context="chapter">
      <assert test="*" role="error">chapter-Elemente dürfen nicht leer sein</assert>
    </rule>
  </pattern>
  <!-- Berechnungen -->
  <pattern id="calc_01">
    <rule context="row[@type = 'dimensions']/cell[4]">
      <let name="volumen" value="../cell[1] * ../cell[2] * ../cell[3] div 1000000"/>
      <assert test="false()" role="error">Das berechnete Volumen beträgt <value-of select="$volumen"/>l</assert>
    </rule>
  </pattern>
  <!-- WebServices -->
  <pattern id="web_01">
    <rule context="/">
      <let name="result" value="(doc('http://localhost:8080/exist/apps/ovidius/schematron/update.xq?name=schematron')//entry)[last()]"/>
      <report test="true()" role="warn">Das Schematron wurde bisher <value-of select="$result/@count"/> Mal ausgeführt.</report>
    </rule>
  </pattern>
</schema>
